;	   ESR  
;	 LCF
;                C/ESR meter
;		  / miron63@tut.by
;		V2
;	 		07/2011
;======================================================================================
;	    PIC16F873
;***************************************************************************************
;* *             *   
;***************************************************************************************

; 1    *  MCLR/Vpp         *  
; 2    *  RA0/AN0          *   .
; 3    *  RA1/AN1          *    .
; 4    *  RA2/AN2/Vref-    *  . Set
; 5    *  RA3/AN3/Vref+    *   -  Lx/Cx
; 6    *  RA4/T0CKI        *  .+/"0"
; 7    *  RA5/AN4/SS       *  .-
; 8    *  Vss              *  GND
; 9    *  OSC1/CLKIN       *   4433619 .
; 10   *  OSC2/CLKOUT      *   4433619 .
; 11   *  RC0/T1OSO/T1CKI  *   .
; 12   *  RC1/T1OSI/CCP2   *  . LC
; 13   *  RC2/CCP1         *  . F_metr
; 14   *  RC3/SCK/SCL      *  . ESR 

; 15   *  RC4/SDI/SDA      *  
; 16   *  RC5/SDO          *   (=33)
; 17   *  RC6/TX/CK        *  , I=2mA
; 18   *  RC7/RX/DT        *  , I=10mA
; 19   *  Vss              * +5V
; 20   *  Vdd              * GND
; 21   *  RB0/INT          * LCD_D4
; 22   *  RB1              * LCD_D5
; 23   *  RB2              * LCD_D6
; 24   *  RB3/PGM          * LCD_D7
; 25   *  RB4              * LCD_R/S
; 26   *  RB5              * LCD_E
; 27   *  RB6/PGC          *
; 28   *  RB7/PGD          * .

;****************************************************************************************
Kn_Set  		equ 2
Kn_Plus  		equ 4
Kn_Minus  		equ 5
;****************************************************************************************
	 list      p=PIC16F873a
     #include  P16F873a.inc ; 4433619 .
	__CONFIG _CP_OFF & _BODEN_ON & _XT_OSC  & _WDT_OFF & _PWRTE_ON & _DEBUG_OFF & _CPD_OFF & _LVP_OFF

	CBLOCK 0x20
;************  . *****************************
        REGA0				;lsb
        REGA1
        REGA2
        REGA3				;msb

        REGB0				;lsb
        REGB1
        REGB2
        REGB3				;msb

        REGC0				;lsb
        REGC1
        REGC2
        REGC3				;msb

	DSIGN				;Digit Sign. 0=positive,1=negative
	DIGIT1				;MSD
	DIGIT2
	DIGIT3
	DIGIT4
	DIGIT5				;Decimal (BCD) digits
	DIGIT6
	DIGIT7
	DIGIT8
	DIGIT9
	DIGIT10	

        MTEMP
        MCOUNT
        DCOUNT
;--------------	  ESR --------------------
	W_TEMP		;   
	STATUS_TEMP
	PCLATH_TEMP

	Temp
	Temp1
	Temp2
	Temp3
	Temp4

	Count1
	Count2
	Count3
 	Count4   
	T0
	T1
	T2
	T3
	T4
	T5	
;************
	AX	;  
	A0
	A1
	A2	;  
	A3
	A4
;************
	BCD0	;  
	BCD1
	BCD2
	BCD3
	Flags       ;- 0=1 -Test_R
      Flag_F;- 0- ,1-Cx1000u,2-Cx10u,3-Cx1u,4-Rx100om,5-Rx10om,6-Rx1om,7- R.
      Uadc_min_H
      Uadc_min_L
      Uadc_max_H
      Uadc_max_L
	Lcd_esr_H
	Lcd_esr_L
	EE_Rx1	;.   ESR  ~2 Om.
	EE_Rx2	;.   ESR  ~20 Om.
	EE_Rx3	;.   ESR  ~100 Om.
;  .
	 Cx1_H      ; . ESR+Cx 1 ,  
	 Cx1_L      ; . ESR+Cx 1 ,  
	 Cx2_H	;   ,  
	 Cx2_L 	;   ,  
       Cou_adcL   ; -   ,  	
       Cou_adcH   ; -   ,  
       Granica	; .   Cx

	 EE_Cx1	;.    .
	 EE_Cx2	;.     ~2.
	 EE_Cx3	;.     ~2.
	 StBy_H	;
	 StBy_L	;
	 EE_Cx_p
	 EE_Lx_p
	ENDC
;=============================================================================================
	ORG		0x2100   	;  EEPROM
;					; 	 EEPROM

;     :
Cx_1_2		DE	0x7F, 0x00, 0x7F, 0x00	;  2  127- .
Cx_3  		DE	0x7F, 0x00, 0x00, 0x00	;  2  127- .
				  ;R_DC_000
Rx_000  		DE	0x14, 0x0A, 0x00, 0x00	; "0".
Esr_1 		DE	0x7F, 0x00, 0x00, 0x00	;  2 Om   127- .
Esr_10      	DE	0x64, 0x00, 0x00, 0x00	;  20 Om  100- .
Esr_100		DE	0x64, 0x00, 0x00, 0x00	;  100 Om 100- .
;*********************************************************************************************
EE1 		DE	0x00, 0x00, 0x00, 0x00	;
EE2      	DE	0x00, 0x00, 0x00, 0x00	;
EE3		DE	0x00, 0x00, 0x00, 0x00	;
;    Lx---
C_Lx		DE	0x19, 0x64, 0x00, 0x00 ; 0x24,0x25
;    Lx---*10
L_Lx		DE	0x27, 0x10, 0x7F, 0x00 ; 0x28,0x29, 0x2A - . .  Lx
;*********************************************************************************************
;     Cx---*10
C_Cx		DE	0x19, 0x64, 0x7F, 0x00 ; 0x2C,0x2D, 0x2E - . .  Cx

;==============================================================================================
;==============================================================================================
		org 	0x780 ; 
Table
	addwf	PCL,F
omega		dt	b'00000000'	; 
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00001010'
		dt	b'00011011'
		dt	b'00000000'
		
mu		dt	b'00000000'
		dt	b'00000000'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00010010'
		dt	b'00011110'
		dt	b'00010001'
		dt	b'00010000'

dat_max	dt	b'00000000'	; . .
		dt	b'00001110'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'
		
dat_1 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'

dat_2 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'
		
dat_3 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00011111'
		dt	b'00000000'

dat_min 	dt	b'00000000'	; .
		dt	b'00001110'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00010001'
		dt	b'00011111'
		dt	b'00000000'

;***********************************************************************
;=======================================================================
;                 
		org 	0x00 
		goto		init
;------------------ Interrupt -----------------------------------------;
		org		0x004
;------------------ --------------------------------;
;		movwf   W_TEMP		
;		swapf   STATUS,W	      
;		clrf	STATUS
;		movwf   STATUS_TEMP	
;		movf	PCLATH,W
;		movwf	PCLATH_TEMP
;----------------------------------------------------------------------; 	      
;  .
;------------------ --------------------------------;		
;		movf	PCLATH_TEMP,W
;		movwf	PCLATH
;		swapf	STATUS_TEMP,W	
;		movwf   STATUS		
;		swapf   W_TEMP,F        
;		swapf   W_TEMP,W        
;		bcf        PIR1,0	;clear interrupt flag
		retfie		;  		
;-------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------;
init
;-------------------------------------------------------------------------------;
;       , ,TMR0,TMR1                                      ;
;-------------------------------------------------------------------------------;
            bsf    STATUS,RP0          ;  1
            movlw B'11111111'          ;  PortA  
            movwf  TRISA
            movlw  0x00                ;  PortB  
            movwf  TRISB

            movlw B'00000001'          ;RC0   
            movwf  TRISC

             bcf  OPTION_REG,7         ;   PortB 7

  		; 
		movlw	 b'10000100'	   ; , Vdd, Vss, AN0, AN1, AN3
		movwf	 ADCON1
            bcf    STATUS,RP0          ;  0

            movlw B'11000110'      ;.  . . ESR.
            movwf   PORTC
            clrf Flag_F
            clrf Flags
		clrf	StBy_H
		clrf	StBy_L
;----------------------------------------------------------------------;
			     bsf   PCLATH,3    ; 1
                       call Init_LCD 
 			     bcf   PCLATH,3    ; 0
         	bsf  PORTB,7		; Power on.
;----------------------------------------------------------------------;
             call Z_G		  ;  .
;----------------------------------------------------------------------;
 
;    
          btfsc PORTA,Kn_Minus	; .-,  , 
		goto $+6
           call TEXT_Service
           call  Pause01s
          	bsf  Flag_F,0     ; .  "SERVICE.inc"
          btfss PORTA,Kn_Minus	; .-,  , 
		goto $-1

          btfsc PORTA,Kn_Plus	; .+,  , ESR
		goto $+6
           call TEXT_Service
           call  Pause01s
          	bsf  Flag_F,7     ; ESR.  "SERVICE.inc"
          btfss PORTA,Kn_Plus	; .+,  , 
		goto $-1
  	
          btfsc PORTA,Kn_Set	; .+,  , I.
		goto $+4
           call TEXT_Service
           call  Pause01s
           call  Test_10mA
  
;-------------------------------------------------------------------------------------;
;  EEPROM     04h      EE_Cx3.
            movlw      0x04           ;     EEPROM 04h
	call LO_EEPR_1
           movwf EE_Cx3			  ;.     ~2
;-------------------------------------------------------------------------------------;
;  EEPROM     00h      EE_Cx2.
            movlw      0x00           ;     EEPROM 00h
	call LO_EEPR_1
           movwf EE_Cx2			  ;.     ~2
;-------------------------------------------------------------------------------------;
;  EEPROM     02h      EE_Cx1.
            movlw      0x02           ;     EEPROM 02h
	call LO_EEPR_1
           movwf EE_Cx1			  ;.    .
;-------------------------------------------------------------------------------------;
;-------------------------------------------------------------------------------------;
;  EEPROM     14h      EE_Rx3.
            movlw      0x14           ;     EEPROM 14h
	call LO_EEPR_1
           movwf EE_Rx3			  ;.   ESR ~20-100 Om.
;-------------------------------------------------------------------------------------;
;  EEPROM     10h      EE_Cx2.
            movlw      0x10           ;     EEPROM 10h
	call LO_EEPR_1
           movwf EE_Rx2			  ;.   ESR ~2-20 Om.
;-------------------------------------------------------------------------------------;
;  EEPROM     0Ch      EE_Cx1.
            movlw      0x0C           ;     EEPROM 0Ch
	call LO_EEPR_1
           movwf EE_Rx1			  ;.   ESR ~0-2 Om.
;-------------------------------------------------------------------------------------;

START
	btfsc   Flag_F,0        ; Flag_F,0=1 (0- )     -."0".
	goto $+5
	btfsc   Flag_F,7        ; Flag_F,7=1 (7- R)     -."0".
	goto $+3
      btfss PORTA,Kn_Plus	; .+,  R.
	goto Rx_DC

	btfsc   Flag_F,0        ; Flag_F,0=1 (0- )     -."0".
	goto $+6
	btfsc   Flag_F,7        ; Flag_F,7=1 (7- R)     -."0".
	goto $+4
      btfsc PORTA,Kn_Minus 	; .+,  ,."0",  R.
	goto $+3
        bsf  Flags,0       ;- 0=1 -Test_R
	goto $+2
       bcf  Flags,0        ;- 0=0 - Test_R

	btfsc   Flag_F,7        ; Flag_F,7=1   . .
        call  Service_Rx

	btfsc   Flag_F,0        ; Flag_F,0=1   . .
        call  Service_Cx

	btfsc   Flags,0        ; Flags,0=1  ,."0",  R.
        call  Test_R
;-------------------------------------------------------------------------------------;
;  StBy  4.
	 incfsz StBy_L,f	;
	goto $+9
	 incf StBy_H,f	;
	movlw    0x03 	;   StBy.
      subwf    StBy_H,W ;
 	btfss STATUS,Z
	goto $+4
	bsf   PCLATH,3      ; 1
	call  PWR_OFF	; Power off.
	bcf   PCLATH,3      ; 0
;-------------------------------------------------------------------------------------;
     call  Pause01s
     call  Pause01s
     call  Pause01s
;-------------------------------------------------------------------------------------;
 	btfsc   Flags,0         ; Flags,0=1     -Kn_Set.
	goto $+6
	btfsc   Flag_F,0        ; Flag_F,0=1     -Kn_Set.
	goto $+4
	btfsc   Flag_F,7        ; Flag_F,7=1     -Kn_Set.
	goto $+2
            btfsc  PORTA,Kn_Set	; 
		goto $+3
 		bsf   PCLATH,3      ; 1
       	GOTO LMETR
;-------------------------------------------------------------------------------------;
;  2mA- ./10 .
Scan_2mA10

		movlw		b'11010110' ;  
		movwf		PORTC; 
	; .   .
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause800us
		movlw		b'10000110' ;.   1mA, 6=0.
		movwf		PORTC
;;  R+~20uS   Temp,Temp1
     call  ADC_RA0	;;  R+~20uS
		movlw		b'11010110' ;  
		movwf		PORTC		; 

		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L
;----------------------------------------------------------------------;
;    768(300), .
	movlw    0x03 
      subwf    Uadc_max_H,W ;
 	btfsc STATUS,Z
	 goto   TEXT_Scan
	; .   .
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause01s
       goto   Esr_10mA
;----------------------------------------------------------------------;
TEXT_Scan
       	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0
	movlw .7	;
      movwf REGB0	;
  call  divide_1		;.    REGA    
	 call bin2dec_1           ;  REGA ---> DIGIT
;----------------------------------------------------------------------;
       call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1	            ;   1- 
      ; movlw " "
      ; call  SendASCII_1

       movlw "R"
       call  SendASCII_1
       movlw "x"
       call  SendASCII_1
       movlw ">"
       call  SendASCII_1
       movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1
	 movlw .1			; 
	 call  SendASCII_1
       movlw " "
       call  SendASCII_1
       movlw "="
       call  SendASCII_1
	       movlw "S"
       call  SendASCII_1
       movlw "c"
       call  SendASCII_1
       movlw "a"
       call  SendASCII_1
       movlw "n"
       call  SendASCII_1
        movlw "="
       call  SendASCII_1
       call  Line2_1	            ;   1- 
            call CLR_Line_1
       call  Line2_1	            ;   1- 
       movlw "C"
     call  SendASCII_1
        movlw "x"
       call  SendASCII_1
       movlw ">"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
      movlw "-"
       call  SendASCII_1
      movlw "-"
      call  SendASCII_1
		bsf   PCLATH,3      ; 1
       call  Ubat
		bcf  PCLATH,3      ; 0
	goto START
;----------------------------------------------------------------------;
;**********************************************************************; 
; Esr. I.-10mA. . - 330.  
Esr_10mA
	movlw	.50   ; - .
	movwf Count1
	clrf BCD0	;  
	clrf BCD1
	clrf BCD2
	clrf BCD3
	clrf 	A0	;  
	clrf 	A1
	clrf 	A2
	clrf 	A3
CIKL_Esr_10mA
	clrf	StBy_H
	clrf	StBy_L
	call  CLRF_REG_MAT_1
		movlw		b'11010110' ;  
		movwf		PORTC		; 

      call  Pause800us
      call  Pause800us
      call  Pause800us
      call  Pause800us
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
      call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 REGA1
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 REGA0
		movwf	 Uadc_min_L
;  "0".       
;  EEPROM     08h      REGB0.
            movlw      0x08  
		call LO_EEPR_1
            movwf REGB0	   ;.   "0".
      call  subtract_1	;.    REGA	= 517
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
       call  CLRF_REG_MAT_1
;    ,   BCD0-3.
	movf BCD0, W
	movwf REGB0
	movf BCD1, W
	movwf REGB1
	movf BCD2, W
	movwf REGB2
	movf BCD3, W
	movwf REGB3
	 call add_1
		movf	 REGA0,W
		movwf	 BCD0
		movf	 REGA1,W
		movwf	 BCD1
		movf	 REGA2,W
		movwf	 BCD2
		movf	 REGA3,W
		movwf	 BCD3
      call  Pause800us
       call  CLRF_REG_MAT_1
;-----------------------------------
;   R+~40uS.
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
	  ;delay 
            movlw       .6
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
     call  ADC_RA0	;  R+~40uS.  Temp,Temp1 
		movlw		b'11010110' ;  
		movwf		PORTC		; 

;    768(300), Esr_10mA10.
	movlw    0x03 
      subwf    Temp1,W ;
 	btfsc STATUS,Z
	 goto   Esr_10mA10
		movf	 Temp1,W
		movwf	 Uadc_max_H
		movwf	 REGA1
		movf	 Temp,W
		movwf	 REGA0
		movwf	 Uadc_max_L
;  "0".       
;  EEPROM     08h      REGB0.
            movlw      0x08  
		call LO_EEPR_1
            movwf REGB0	   ;.   "0".
      call  subtract_1	;.    REGA	= 517
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
       call  CLRF_REG_MAT_1
;    ,   A0-3.
	movf A0, W
	movwf REGB0
	movf A1, W
	movwf REGB1
	movf A2, W
	movwf REGB2
	movf A3, W
	movwf REGB3
	 call add_1
		movf	 REGA0,W
		movwf	 A0	;  
		movf	 REGA1,W
		movwf	 A1
		movf	 REGA2,W
		movwf	 A2
		movf	 REGA3,W
		movwf	 A3
           decfsz Count1, F	 ;   
        goto  CIKL_Esr_10mA
;;;
; ----------------------------------------------------
; Umax-Umin=REGB
	movf BCD0, W
	movwf REGB0
	movf BCD1, W
	movwf REGB1
	movf BCD2, W
	movwf REGB2
	movf BCD3, W
	movwf REGB3
      call  subtract_1	;.    REGA
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1 
	movf REGA0, W
	movwf REGB0
	movf REGA1, W
	movwf REGB1
	movf REGA2, W
	movwf REGB2
	movf REGA3, W
	movwf REGB3
;Umin-REGB= Rx(BCD0-3)
	movf BCD0, W
	movwf REGA0
	movf BCD1, W
	movwf REGA1
	movf BCD2, W
	movwf REGA2
	movf BCD3, W
	movwf REGA3
   call  subtract_1	;.    REGA = 0
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
      call  CLRF_REG_MAT_1 
;
        call  CLR_REGB_1
	movlw .5	
      movwf REGB0	
  call  divide_1		;.    REGA
		bsf   PCLATH,3      ; 1
  		call  round
		bcf   PCLATH,3      ; 0
	movf REGA0, W
	movwf BCD0
	movf REGA1, W
	movwf BCD1
	movf REGA2, W
	movwf BCD2
	movf REGA3, W
	movwf BCD3
 ;-------------------------------------------------------------------------------------;
; ESR
        call  CLRF_REG_MAT_1
	movlw 0x03	;873  
      movwf REGB1	;
	movlw 0x69	;
      movwf REGB0	;

	movf	 EE_Rx1,W
      movwf REGA0
	call add_1	;1000

        call  CLR_REGB_1

	movf BCD0, W
	movwf REGB0
	movf BCD1, W
	movwf REGB1
	movf BCD2, W
	movwf REGB2
	movf BCD3, W
	movwf REGB3
	call multiply_1

        call  CLR_REGB_1
	movlw 0x0C	;
      movwf REGB1	;
	movlw 0xC1	;
      movwf REGB0	;

  call  divide_1		;.    REGA
		bsf   PCLATH,3      ; 1
  		call  round
		bcf   PCLATH,3      ; 0
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L
	
          	bsf  Flag_F,6 
          	bcf  Flag_F,5
           	bcf  Flag_F,4
      btfsc Flags,0 	;Flags-- 0=1 -Test_R,  ,."0",  R.
       	goto START
	goto Cx 
;-------------------------------------------------------------------------  
;-------------------------------------------------------------------------  
; Esr. I.-10mA. . - 33. R= ~2-25 .    
Esr_10mA10

	; .  . .. - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause005s
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
;  R+~20uS 
     call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
     call  Pause800us
;   R+~40uS.
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
		;delay = 20 machine cycles
            movlw       .6
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
           ; nop
     call  ADC_RA0	;  R+~40uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L
	; .  . .. - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0

;    768(300), Esr_2mA10.
	movlw    0x03 
      subwf   Uadc_max_H,W ;
 	btfsc STATUS,Z
	 goto   Esr_2mA10

;  
      	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0

		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .102	
      movwf REGB0	;   100 + .
		call multiply_1	;.  -  *100.
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLRF_REG_MAT_1
		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0

	movf	 EE_Rx2,W	;~100
      movwf REGB0

	call multiply_1 ;.
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  subtract_1	;.  -   *100.
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .37	;;   1 - ~35.  
      movwf REGB0	;
  call  divide_1		;  .  -  Rx. 
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L
            
          	bcf  Flag_F,6 
          	bsf  Flag_F,5
           	bcf  Flag_F,4
      btfsc Flags,0 	;Flags-- 0=1 -Test_R,  ,."0",  R.
       	goto START
	goto Cx2 
;----------------------------------------------------------------------;
; Esr. I.-2mA. . - 33. R= ~25-80 .
Esr_2mA10
	; .   . . - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
     call  Pause800us
		movlw		b'10000110' ;.   2mA, 6=0.
		movwf		PORTC
;  R+~20uS 
     call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
     call  Pause800us
;   R+~30uS.
		movlw		b'10000110' ;.   2mA, 6=0.
		movwf		PORTC
		;delay 
            movlw       .2
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
            nop
            nop
          ;  nop
;  R+~30uS.
     call  ADC_RA0	;  R+~30uS.  Temp,Temp1.
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W
		movwf	 Uadc_max_H
		movf	 Temp,W
		movwf	 Uadc_max_L
	; .   . . - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0

;    768(300),  ESR.
	movlw    0x03 
      subwf   Uadc_max_H,W ;
 	btfsc STATUS,Z
		goto Esr_x
;  
      	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0

		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .210	;   ,     Uadc_max-  2."0"
      movwf REGB0	;   100 , 2*100 =200 + .
        call multiply_1	;.  -  *100.
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLRF_REG_MAT_1
		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0
	movf	 EE_Rx3,W	;~100
      movwf REGB0
	call multiply_1 ;.
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  subtract_1	;.  -   *100.
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
        call  CLRF_REG_MAT_1

        call  CLR_REGB_1
	movlw .71	;;   1 - ~70.  
      movwf REGB0	;
        call  divide_1		;  .  -  Rx. 
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L

          	bcf  Flag_F,6 
          	bcf  Flag_F,5
           	bsf  Flag_F,4
      btfsc Flags,0 	;Flags-- 0=1 -Test_R,  ,."0",  R.
       	goto START
  	goto Cx3
;----------------------------------------------------------------------;
Esr_x
      call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1	            ;   1- 
  ;     movlw " "
  ;    call  SendASCII_1

       movlw "E"
       call  SendASCII_1
       movlw "s"
       call  SendASCII_1
       movlw "r"
       call  SendASCII_1
       movlw ">"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
       movlw "-"
       call  SendASCII_1
	goto Cx3		;   .
;----------------------------------------------------------------------;
;----------------------------------------------------------------------;
;  .
;----------------------------------------------------------------------;
;Cx   ~2  ~15..
Cx2 
	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0
		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLR_REGB_1
; ,   ,     .
	movlw .50	;   "50"(~15),     .
	movwf REGB0	;
   call  subtract_1	;.    REGA
	movf   REGA3,f   
      btfss   STATUS,Z 
        goto   Cx
   
; .     ~2.
	call  CLRF_REG_MAT_1
	;   .
	movlw 0x04	; 
      movwf REGA1	;
	movlw 0x60	;
      movwf REGA0	;

	movf  EE_Cx2,W 		  ;.     ~2,  
      movwf      REGB0          ;  04h-EEPROM   W   REGB0.
	call add_1
	;----	 
        call  CLR_REGB_1
	movlw .54	;
	movwf REGB0	;
	call multiply_1	; ~70 000
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  divide_1		;.    REGA
         	bcf  Flag_F,1 
     bsf  Flag_F,2 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u, .
           	bcf  Flag_F,3

       goto   Lcd_Cx

;----------------------------------------------------------------------;
;Cx   ~2..
Cx3 
   	call  CLRF_REG_MAT_1
		movf	 Uadc_max_H,W
		movwf	 REGA1
		movf	 Uadc_max_L,W
		movwf	 REGA0
		movf	 Uadc_min_H,W
		movwf	 REGB1
		movf	 Uadc_min_L,W
		movwf	 REGB0
   call  subtract_1	;.    REGA
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

        call  CLR_REGB_1
; ,   ,   .
	movlw .5	;   "5",    .
	movwf REGB0	;
   call  subtract_1	;.    REGA
	movf   REGA3,f   
      btfss   STATUS,Z  
        goto   TEXT_Cx_no
; .     ~2.
	call  CLRF_REG_MAT_1
	;   .
	movlw .50	; 
	movwf REGA0	;
	movf  EE_Cx3,W 			 ;.     ~2,  
           movwf      REGB0          ;  04h   W   REGB0.
	;----	
	call multiply_1	; ~7 000
        call  CLR_REGB_1
		movf	 BCD1,W	; 
		movwf	 REGB1
		movf	 BCD0,W	; 
		movwf	 REGB0
   call  divide_1		;.    REGA 
	         	bcf  Flag_F,1 
     			bcf  Flag_F,2 
           	bsf  Flag_F,3 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u.
       goto   Lcd_Cx

;======================================================================;
;----------------------------------------------------------------------;
;  .
Cx
          ;  movlw  0x2F	; .  (Cx~120 000)
  		movlw  0x14		; .  (Cx~60 000)
        	movwf  Granica 	; .	
            movlw  .1
        	movwf  Cou_adcL		;  . ESR+Cx 1 .
        	clrf  Cou_adcH
	; .   . . - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
;    Cx
       call  Pause800us
;----------------------------------------------------------------------;
;  . ESR+Cx 1 .
		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
     call  ADC_RA0 ;         Temp,Temp1.
		movf	 Temp1,W
		movwf	 Cx1_H
		movf	 Temp,W
		movwf	 Cx1_L
		nop
           goto   CI     ;6,7Cikl
;----------------------------------------------------------------------;
;          0x200(512). 
CIKL  
;delay = 21 machine cycles
      	nop
		nop
		nop
		nop
		nop
		nop
CI_1 		nop
CI		nop
		nop
		nop
		nop
		nop
		nop
 		nop
CI_2		nop
		nop
		nop
		nop
		nop
      	nop
		nop
     call  ADC_RA0 ;         Temp,Temp1.
;    512(200),  .
	movlw    0x02
      subwf   Temp1,W 	;   ,  
 	btfsc STATUS,C  ;3,4
      goto  CI_3      ;
		;  .
           incfsz Cou_adcL, F  ;5  -   ,  
            goto  CIKL         ;6,7Cikl
            incf Cou_adcH, F   ;1  -   ,  
;    ,     
		movf	 Temp1,W 	; 2    ,  
       	subwf Cx1_H,W	; 3
		btfss STATUS,Z	; 4
            goto  CI_1 		; 5,6
		movf	Cx1_L,W		; 6
       	subwf Temp,W	;   ,  
		movwf	 Temp2	; 8
		movlw    0x02	; 9
	      subwf Temp2,W	; 10
		btfss STATUS,C	; 11,12
              goto  TEXT_Cx_no
           decfsz Granica, F	 ;0x14  .  (Cx~60 000), .
            goto  CI_2         ;13,14 Cikl
              goto  TEXT_Cx_no
CI_3
		movlw		b'11010110' ;  
		movwf		PORTC		; 
		movf	 Temp1,W	;   ,  
		movwf	 Cx2_H
		movf	 Temp,W	;   ,  
		movwf	 Cx2_L

	; .   . . - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
;----------------------------------------------------------------------;
;-----  .
Cx_mat
	;   .		
	call  CLRF_REG_MAT_1
	movlw .10
	movwf REGA0	;
	    movf  EE_Cx1,W 	      ;.    . 
          movwf      REGB0          ;  02h   W   REGB0.
   call  multiply_1	;.    REGA 
	  call  CLR_REGB_1
	movlw 0x0E;10	;
	movwf REGB1	;
	movlw 0x08	; 
	movwf REGB0	;
	call add_1	; ~5 588
	;----	
	  call  CLR_REGB_1
		movf	 Cou_adcL,W	;  -  .
		movwf	 REGB0
		movf	 Cou_adcH,W	;  -  .
		movwf	 REGB1
    call  multiply_1	;.    REGA 
	movf    REGA3,W	;
	movwf   BCD3	; 
	movf    REGA2,W	;
	movwf   BCD2	; 
	movf    REGA1,W	;
	movwf   BCD1	; 
	movf    REGA0,W	;
	movwf   BCD0	; 

	call  CLRF_REG_MAT_1
		movf	 Cx2_H,W	;,    
		movwf	 REGA1
		movf	 Cx2_L,W	;,    
		movwf	 REGA0

		movf	 Cx1_H,W	;,    
		movwf	 REGB1
		movf	 Cx1_L,W	;,    
		movwf	 REGB0
    call  subtract_1	;.    REGA,
; ,   ,   .
	movf    REGA1,W	; 
	movwf   Temp1	;
	movf    REGA0,W	;
	movwf   Temp	; 
        call  CLR_REGB_1
	movlw .5	;   "5",    .
	movwf REGB0	;
   call  subtract_1	;.    REGA
	movf   REGA3,f   
      btfss   STATUS,Z  
        goto   TEXT_Cx_no

	call  CLRF_REG_MAT_1
	movf    Temp1,W	;
	movwf   REGB1	;
	movf    Temp,W	;
	movwf   REGB0	;

	movf    BCD3,W	; 
	movwf   REGA3	;
	movf    BCD2,W	; 
	movwf   REGA2	;
	movf    BCD1,W	; 
	movwf   REGA1	;
	movf    BCD0,W	; 
	movwf   REGA0	;

    call  divide_1	;.    REGA
	     bsf  Flag_F,1 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u.
     			bcf  Flag_F,2 
           		bcf  Flag_F,3 
          goto  Lcd_Cx
;----------------------------------------------------------------------;
;----------------------------------------------------------------------;
TEXT_Cx_no
		movlw		b'11010110' ;  
		movwf		PORTC		; 
	; .  . .
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0

       call  Line2_1	            ;   2- 
            call CLR_Line_1
       call  Line2_1	            ;   2- 
       movlw "C"
       call  SendASCII_1
        movlw "x"
       call  SendASCII_1
       movlw ">"
       call  SendASCII_1
       movlw "-"
        call  SendASCII_1
       movlw "-"
        call  SendASCII_1
      movlw "n"
        call  SendASCII_1
      movlw "o"
       call  SendASCII_1
       movlw "-"
        call  SendASCII_1
       movlw "-"
        call  SendASCII_1
    ; btfsc Flags,6 	;Flags-- 6=1 - R   1.5 
     ;          call Mat_R
      goto   Lcd_esr 
Lcd_Cx
       call bin2dec_1           ;  REGA ---> DIGIT
;---     .  Cx -- ---
       call  Line2_1	            ;   1- 
            call CLR_Line_1
       call  Line2_1	            ;   1- 
 
       movlw  "C"		
       call  SendASCII_1
       movlw  "x"		
       call  SendASCII_1
       movlw  ">"		
       call  SendASCII_1



       btfss  Flag_F,1 ;- 0- , 1-Cx1000u, 2-Cx10u, 3-Cx1u.
          goto  DIGIT_Cmin ;    Cx --.--

;   ------------------------------------------ 

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   C5       ;   xx.xxx uF

	movlw    0x01	   ; 
        subwf    DIGIT7,0  ;
 	btfsc STATUS,C
       goto   C4       ;   x.xxx uF

	movlw    0x01	   ; 
        subwf    DIGIT8,0  ;
 	btfsc STATUS,C
       goto   C3       ;   xxx uF
       goto   C2       ;   xx uF

C5       movf  DIGIT6,0
       addlw "0"
       call  SendASCII_1

C4       movf  DIGIT7,0
       addlw "0"
       call  SendASCII_1
 	 movlw  " "	
       call  SendASCII_1

C3      movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1

	movf   DIGIT6 ,f   	;   10 000,     .
      btfss   STATUS,Z       
           goto  Cx6
C2       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1

	movf   DIGIT7 ,f   	;   1000,    .
      btfss   STATUS,Z       
           goto  $+7
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1
          goto  $+5
Cx6
       movlw  "0"	
       call  SendASCII_1
       movlw  "0"	
       call  SendASCII_1
         goto   Txt_uF 

DIGIT_Cmin	;    Cx---.--

	movf   DIGIT7,f   ;   
      btfsc   STATUS,Z       
           goto  $+4
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII_1
    
	 movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1
          movlw "."
       call  SendASCII_1
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1

	movf   DIGIT7 ,f   ;   10,    .
      btfss   STATUS,Z       
           goto  $+4
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1
 
Txt_uF   movlw .2	; 
        call  SendASCII_1
           movlw "F"
       call  SendASCII_1
;---------------------------------------------------------------------------------
;   ESR.
Lcd_esr
      	call  CLRF_REG_MAT_1
		movf	 Lcd_esr_H,W
		movwf	 REGA1
		movf	 Lcd_esr_L,W
		movwf	 REGA0
       call bin2dec_1           ;  REGA ---> DIGIT
	       call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1	            ;   1- 
       movlw "R"
       call  SendASCII_1
         movlw  "x"		
       call  SendASCII_1
       movlw  ">"		
       call  SendASCII_1

	btfsc   Flag_F,6;- 0- , 1-Cx10u, 4-Rx100om, 5-Rx10om, 6-Rx1om, 7- R.
        goto $+4

	movf   DIGIT7,f   ;   
      btfsc   STATUS,Z       
           goto  $+4
      movf  DIGIT7,0
       addlw "0"
       call  SendASCII_1
 
	btfss   Flag_F,6; Esr-6-Rx1om.
       goto  $+3
       movlw ","
       call  SendASCII_1

       movf  DIGIT8,0
       addlw "0"
       call  SendASCII_1
	btfss   Flag_F,5; Esr-10om,5-Rx10om.
       goto  $+3
       movlw ","
       call  SendASCII_1

       movf  DIGIT9,0
       addlw "0"
       call  SendASCII_1
	btfss   Flag_F,4; Esr-100om, 4-Rx100om.
       goto  $+3
       movlw ","
       call  SendASCII_1

	btfss   Flag_F,5; Esr-10om.    Rx --.--
       goto  $+4
	movf   DIGIT7,f   
      btfss   STATUS,Z       
           goto  $+4
       movf  DIGIT10,0
       addlw "0"
       call  SendASCII_1

	 movlw .1			; 
	 call  SendASCII_1

	       goto   START 
;----------------------------------------------------------------------;
Rx_DC
 
       call  Line2_1	            ;   2- 
            call CLR_Line_1
;----------------------------------------------------------------------; 
; Rx_DC. I.-10mA. . - 330.  
Rx_DC_10mA
          	bsf  Flag_F,6 
          	bcf  Flag_F,5
           	bcf  Flag_F,4
      call  Pause01s
      call  Pause01s
  		movlw		b'01000110' ;.   10mA,7=0.
		movwf		PORTC
      call  ADC_RA0	; .  Temp,Temp1.
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
;    768(300), Esr_10mA10.
	movlw    0x03 
      subwf    Temp1,W ;
 	btfsc STATUS,Z
	 goto   Rx_DC_10mA10
;--------------------------
	movlw	.100
	movwf Count1
	clrf BCD0	;  
	clrf BCD1
	clrf BCD2
	clrf BCD3
CIKL_Count1
	call  CLRF_REG_MAT_1
      call  ADC_RA0	; .  Temp,Temp1.
		movf	 Temp1,W
		movwf	 REGA1
		movf	 Temp,W
		movwf	 REGA0
      btfss PORTA,Kn_Minus 	; .-,  ,."0",  R.
	goto Zero_Rx_DC
;  "0".       
;  EEPROM     08h      REGB0.
            movlw      0x09  
		call LO_EEPR_1
            movwf REGB0	   ;.   "0".
      call  subtract_1	;.    REGA	= 517
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z  
       call  CLRF_REG_MAT_1

	movf BCD0, W
	movwf REGB0
	movf BCD1, W
	movwf REGB1
	movf BCD2, W
	movwf REGB2
	movf BCD3, W
	movwf REGB3
	 call add_1
		movf	 REGA0,W
		movwf	 BCD0
		movf	 REGA1,W
		movwf	 BCD1
		movf	 REGA2,W
		movwf	 BCD2
		movf	 REGA3,W
		movwf	 BCD3
           decfsz Count1, F	 ;   
        goto  CIKL_Count1
;
        call  CLR_REGB_1
	movlw .10	
      movwf REGB0
          call  divide_1	  ;.    REGA
		bsf   PCLATH,3      ; 1
  		call  round
		bcf   PCLATH,3      ; 0
	movf REGA0, W
	movwf BCD0
	movf REGA1, W
	movwf BCD1
	movf REGA2, W
	movwf BCD2
	movf REGA3, W
	movwf BCD3
; ESR
        call  CLRF_REG_MAT_1
	movlw 0x03	;873  
      movwf REGB1	;
	movlw 0x69	;
      movwf REGB0	;

	movf	 EE_Rx1,W
      movwf REGA0
	call add_1	;1000

        call  CLR_REGB_1

	movf BCD0, W
	movwf REGB0
	movf BCD1, W
	movwf REGB1
	movf BCD2, W
	movwf REGB2
	movf BCD3, W
	movwf REGB3
	call multiply_1

        call  CLR_REGB_1
	movlw 0x0C	;;
      movwf REGB1	;
	movlw 0xC1;B5	;;
      movwf REGB0	;

  call  divide_1		;.    REGA
		bsf   PCLATH,3      ; 1
  		call  round
		bcf   PCLATH,3      ; 0
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L
	
	       goto   Lcd_esr
Rx_DC_10mA10
     call  Pause01s
          	bcf  Flag_F,6 
          	bsf  Flag_F,5
           	bcf  Flag_F,4
	; .  . .. - 33.
            bsf    STATUS,RP0          ;  1
            movlw B'00100001'          ; RC0,RC1,RC5   
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
      call  Pause01s
;  
     call  ADC_RA0	;  R+~20uS.  Temp,Temp1.
		movf	 Temp1,W
		movwf	 Uadc_min_H
		movf	 Temp,W
		movwf	 Uadc_min_L
	; .  . .. - 330.
            bsf    STATUS,RP0          ;  1
            movlw B'00000001'          ; RC1,RC3,  
            movwf  TRISC
            bcf    STATUS,RP0          ;  0
;
;-----------------------------------
        call  CLRF_REG_MAT_1
		movf	 Uadc_min_H,W
		movwf	 REGA1
		movf	 Uadc_min_L,W
		movwf	 REGA0

	movf	 EE_Rx2,W	;~100
      movwf REGB0

	call multiply_1 ;.
        call  CLR_REGB_1
	movlw .37	;;   1 - ~35.  
      movwf REGB0	;
  call  divide_1		;  .  -  Rx. 
		movf	 REGA1,W
		movwf	 Lcd_esr_H
		movf	 REGA0,W
		movwf	 Lcd_esr_L

	       goto   Lcd_esr
;----------------------------------------------------
Zero_Rx_DC
            btfsc  PORTA,Kn_Set	; 
       	GOTO Z_EE 
       call  Line1_1	; 1-   
	 call CLR_Line_1
       call  Line1_1	;   1- 
		bsf   PCLATH,3      ; 1
       call Text_save
		bcf   PCLATH,3      ; 0
;    EEPROM 09h. 
		movf	 REGA0,W
            movwf   Temp 
 	 movlw      0x09	;   EEPROM
	 call SAV_EEPR_1
  
            btfss  PORTA,Kn_Set	; 
       	GOTO $-1
Z_EE   

      call bin2dec_1  
       call  Line1_1	            ;   1- 
            call CLR_Line_1
       call  Line1_1
       movlw "Z"
       call  SendASCII_1
       movlw ">"
       call  SendASCII_1
      call  LcD_DIGIT_8_10
      
;  EEPROM     08h      REGB0.
            movlw      0x09  
		call LO_EEPR_1
            movwf REGA0	   ;.   "0".
      call bin2dec_1  
       call  CLRF_REG_MAT_1
       call  Line2_1	            ;   1- 
            call CLR_Line_1
       call  Line2_1
       movlw "E"
       call  SendASCII_1
       movlw "E"
       call  SendASCII_1
       movlw ">"
       call  SendASCII_1
      call  LcD_DIGIT_8_10

	       goto   Rx_DC_10mA
;----------------------------------------------------------------------;
;==========================================================;
;----------------------------------------------------------------------;
;    ..
ADC_RA0	
		movlw		b'10000001'   ;Fosc/32,  0,   .
		movwf		ADCON0
            movlw       .5
        	movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		bsf		ADCON0,2	  ; - 
		btfsc		ADCON0,2
		goto		$-1		  ;   
		movf	 ADRESH,W
		movwf	 Temp1
            bsf    STATUS,RP0          ;  1
		movf	 ADRESL,W
            bcf    STATUS,RP0          ;  0
		movwf	 Temp
		return
;----------------------------------------------------------------------;
TEXT_Service
       call  Line1_1	            ;   1- 
       movlw " "
       call  SendASCII_1
       movlw "S"
       call  SendASCII_1
        movlw "e"
       call  SendASCII_1
       movlw "r"
        call  SendASCII_1
      movlw "v"
        call  SendASCII_1
      movlw "i"
       call  SendASCII_1
      movlw "c"
        call  SendASCII_1
      movlw "e"
       call  SendASCII_1
		return
;----------------------------------------------------------------------;
;delay = 766 machine cycles
Pause800us   movlw       .255
            movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		return
;----------------------------------------------------------------------;
;delay = 49'996 machine cycles
Pause005s    movlw       .237
            movwf       Temp1
            movlw       .65
            movwf       Temp2
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
  		return
;----------------------------------------------------------------------;
;delay = 99'996 machine cycles
Pause01s    movlw       .220
            movwf       Temp1
            movlw       .130
            movwf       Temp2
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
            nop
		return
;---------------------- Load CGRAM LCD ---------------------
;       .
Z_G
			movlw		b'01001000' ; AC in CGRAM=8
		bsf   PCLATH,3    ; 1
			call		SendINS
		bcf   PCLATH,3    ; 0
			clrf Count2
			movlw		.56			;16   8 
			movwf		Count1
			movlw 		HIGH Table
			movwf 		PCLATH

	      movf		Count2,W
	       	call		Table			;   
		bsf   PCLATH,3    ; 1
			call		SendASCII
		bcf   PCLATH,3    ; 0
			incf		Count2,F
			decfsz	Count1,F
			goto		$-7
		return
;------------------------------------------------------------------------------------;
;  0    .
Pause1s
		bsf   PCLATH,3      ; 1
	call  Pause05sek 
	call  Pause05sek 
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
SendASCII_1
		bsf   PCLATH,3      ; 1
	call  SendASCII
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
SendINS_1
		bsf   PCLATH,3      ; 1
	call  SendINS
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
Line1_1
 		bsf   PCLATH,3      ; 1      
	call  Line1
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
Line2_1
 		bsf   PCLATH,3      ; 1      
	call  Line2
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
CLR_Line_1
 		bsf   PCLATH,3      ; 1      
	 call CLR_Line
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
LO_EEPR_1
 		bsf   PCLATH,3      ; 1
	call LO_EEPR
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
SAV_EEPR_1
 		bsf   PCLATH,3      ; 1
	call SAV_EEPR
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
CLRF_REG_MAT_1
 		bsf   PCLATH,3      ; 1      
	call  clrba
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
CLR_REGB_1
 		bsf   PCLATH,3      ; 1      
	call  CLR_REGB
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
subtract_1
 		bsf   PCLATH,3      ; 1      
	call  subtract
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
divide_1
 		bsf   PCLATH,3      ; 1      
	 call divide
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
bin2dec_1
 		bsf   PCLATH,3      ; 1
	 call bin2dec
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
multiply_1
 		bsf   PCLATH,3      ; 1
	call multiply
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;
add_1
		bsf   PCLATH,3      ; 1
	call add
		bcf   PCLATH,3      ; 0
          	return
;------------------------------------------------------------------------------------;

;************************************************************************
;  
	INCLUDE "SERVICE.inc"
	NOP
;************************************************************************
;***********          1        **********************************
;************************************************************************
  org 	0x800 ;  1

;************************************************************************
;***********          LMETR      **********************************
;************************************************************************

LMETR
	clrf	StBy_H
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.

	 call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
       call Line1
       movlw " "
       call  SendASCII
       movlw "L"
       call  SendASCII
       call Text_Metr
       call Pause05sek 

		 clrf Flag_F		
;************************************************************************          
;            Initialize the ports and timer1                           ;
;----------------------------------------------------------------------;
            bsf    STATUS,RP0
		movlw		b'00000111'; DDDDDDDD
		movwf		ADCON1
            movlw B'00000001'          ;RC0,inputs  other outputs
            movwf  TRISC
            bcf    STATUS,RP0
		bcf	INTCON,7	; 
            movlw  B'00000110'
            movwf  T1CON
            bcf    T1CON,0      ;0  TMR1ON:  TMR1    1=.

;-------------------------------------------------------------------------;
            bsf    PORTC,3	;  ESR
            bsf    PORTC,2	;  F
            bcf    PORTC,1	;  LC
;-------------------------------------------------------------------------;
;  . Lx.
	   movlw      0x2A
	call LO_EEPR
	   movwf  EE_Lx_p
;-------------------------------------------------------------------------;
Restart
;  StBy  4.
	 incfsz StBy_L,f	
	goto $+6		
	 incf StBy_H,f	
	movlw    .3 	;   StBy.
      subwf    StBy_H,W 
 	btfsc STATUS,Z	
        call  PWR_OFF	; Power off.

;----------  F_metr----------------------------------------------;
		btfsc		PORTA,Kn_Set  
   	    goto $+2
           	goto F_metr 
;----------  c_metr----------------------------------------------;
		btfss		PORTA,3  
   	    goto $+2
           	goto _metr 
;---------- ------------------------------------------------;
		btfsc		PORTA,5  
   	    	goto Ser_L
 		movlw .15
		movwf	Count1

	      call 	Pause03sek 
		btfsc	  PORTA,5 
   	    	goto Ser_L  
            decfsz  Count1, F
            goto    $-4

		bcf   PCLATH,3      ; 0
           call TEXT_Service
        call  MENU_Lx_1p
 		bsf   PCLATH,3      ; 1
Ser_L
;     LC .                                        
;    \A0\A1\A2\A3\ A0-A3=((F/10)*)(F/10/2))^2/10
       call LC_F
;-------------------------------------------------------------------------;
;****   1500   ********************************
	movf	 REGA3,f
	btfss STATUS,Z
       goto   A_F 
	movf	 REGA2,f
	btfss STATUS,Z
       goto   A_F 
	movlw    0x04	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   A_F        ;

	 call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
        call  Line1	;   1- 	
	    call  Text_Lx
            goto    Restart
A_F
	clrf	StBy_H
	clrf	StBy_L
;,F/1000
          call  CLR_REGB
		movlw .100
		movwf	 REGB0
  	call  divide		;.

	movf	 REGA2,f
	btfsc STATUS,Z
        goto   Lx_d

       call  CLR_REGB
		bsf Flags,0
		movlw .100
		movwf	 REGB0
  	 call  divide		;.
Lx_d
		movf	 REGA3,W	
		movwf	 BCD3
		movf	 REGA2,W
		movwf	 BCD2
		movf	 REGA1,W	
		movwf	 BCD1
		movf	 REGA0,W
		movwf	 BCD0
;--------------------------------------------------------------
	      btfsc  PORTA,Kn_Plus
	      goto   K_C
	    call   Pause05sek 
		btfsc  PORTA,Kn_Plus
	      goto   K_C
	    call   Cal_L
K_C    
;************   F mkH = 25330/C/F^2 ************************
;L=(25330/2)/C*1000/F 
	movlw 0x4B	 ;1266500000
	movwf REGA3	;
	movlw 0x7D
	movwf REGA2	;
	movlw 0x41
	movwf REGA1	;
	movlw 0xA0
	movwf REGA0	;

;--------------   C xxx pF--------------------------------
;===============================================================================================
;  EEPROM     24h      REGB1.  pF
;-----------------------------------------------------------------------------------------------
         call  CLR_REGB
	   movlw      0x24
	call LO_EEPR
	   movwf      REGB1
;  EEPROM     25h      REGB0.
            movlw      0x25           ;     EEPROM 25h
	call LO_EEPR
            movwf      REGB0          ;  24h   W   EEAdr.
;-----------------------------------------------------------------
	call  divide	;.    REGA 
;   1000.   
	movlw 0x03	;  1000
	movwf REGB1	;
	movlw 0xE8	;
	movwf REGB0	;
    call  multiply	;.    REGA 
 ;-------  F^2 ----------------------------
      movf  BCD3,0  
     	movwf REGB3	;
 	movf  BCD2,0  
	movwf REGB2	;
      movf  BCD1,0  
     	movwf REGB1	;
 	movf  BCD0,0  
	movwf REGB0	;
    call  divide	;.    REGA 
;    Cal_L,  0
;  EEPROM  2-  
      movf  REGA1,0     ;   
    	movwf T3	;
 	movf  REGA0,0  	;  
	movwf T2	;

     btfsc Flags,0
	goto $+5
     call  CLR_REGB
	movlw .100	;  100
	movwf REGB0	;
     call  multiply	;.    REGA 
      clrf Flags


          call  CLR_REGB
;  EEPROM     28h      REGB1.
	   movlw      0x28
	call LO_EEPR
	   movwf      REGB1
;  EEPROM     29h      REGB0.
            movlw      0x29           ;     EEPROM 25h
	call LO_EEPR
            movwf      REGB0          ;  29h   W   REGB0.

;--------------------------------------------------------------------
       call  subtract	;.    REGA  0
;******************   ******************************** 
    
;----------- --------------------------------------------
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
            call  Line1 	;   1- 
   ;    	movlw " "
  ;     	call  SendASCII 
	     	movlw "L"
      	call  SendASCII 
      	movlw "x"
       	call  SendASCII 
       	movlw " "
       	call  SendASCII 

       call bin2dec     ;  REGA ---> DIGIT
;   
 	btfss DSIGN,0
      goto   $+3
       	movlw "-"
       	call  SendASCII
;--------------------------------------------------------------------   
;  ------------------------------------------ 
 
	movlw    0x01	   ; 
        subwf    DIGIT1,0  ;
 	btfsc STATUS,C
       goto   Lx_H         ;   Lx- xx.xx H

	movlw    0x01	   ; 
        subwf    DIGIT2,0  ;
 	btfsc STATUS,C
       goto   Lx_H         ;   Lx- x.xx H

	movlw    0x01	   ; 
        subwf    DIGIT3,0 ;
 	btfsc STATUS,C
       goto  Lx_mH        ;   Lx- xxx.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT4,0 ;
 	btfsc STATUS,C
       goto  Lx_mH1         ;   Lx- xx.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT5,0 ;
 	btfsc STATUS,C
       goto   Lx_mH2      ;    Lx- x.xx mH

	movlw    0x01	  ; 
        subwf    DIGIT6,0 ;
 	btfsc STATUS,C
       goto   Lx_ukH      ;   Lx- xxx.xx ukH

	movlw    0x01	  ; 
        subwf    DIGIT7,0 ;
 	btfsc STATUS,C
       goto   Lx_ukH1     ;   Lx- xx.xx ukH 

       goto   Lx_ukH2     ;   Lx- x.xx ukH 
;-----------------------------------------------------------------------;
;           Lx- xxx.xx uH                                ;
;-----------------------------------------------------------------------; 
Lx_ukH

	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
Lx_ukH1       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
Lx_ukH2       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
      movf  DIGIT10,0
       addlw "0"
       call  SendASCII 
        movlw " "
       call  SendASCII
  ;          call  Line2 	;   2- 
       movlw "u"
       call  SendASCII
       movlw "k"
       call  SendASCII
       movlw "H"
       call  SendASCII
       goto    Restart
;-----------------------------------------------------------------------;
;             Lx- xxxx.x mH                               ;
;-----------------------------------------------------------------------; 
Lx_mH
     
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
Lx_mH1       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
Lx_mH2       movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movlw "."
       call  SendASCII  
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII
  ;          call  Line2 	;   2- 
       movlw "m"
       call  SendASCII
       movlw "H"
       call  SendASCII
        goto    Restart
;-----------------------------------------------------------------------;
;-----------------------------------------------------------------------;
;               Lx- xx.xx H                               ;
;-----------------------------------------------------------------------; 
Lx_H
       
        movf  DIGIT1,0
       addlw "0"
       call  SendASCII
       movf  DIGIT2,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
        movf  DIGIT5,0
          movlw " "
       call  SendASCII
 ;           call  Line2 	;   2- 
       movlw "H"
       call  SendASCII
       movlw "e"
       call  SendASCII 
       movlw "n"
       call  SendASCII
        movlw " "
       call  SendASCII	  
       goto    Restart

;************************************************************************
;***********  *************************************
;************************************************************************
_metr
;-------------------------------------------------------------------------------------;
;  EEPROM      EE_Cx_p.
            movlw      0x2E           ;     EEPROM 2Eh
	call LO_EEPR
           movwf EE_Cx_p	      ;.   ,  Cx/Lx.
;-------------------------------------------------------------------------------------;
	clrf	StBy_H 
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "C"
       call  SendASCII
       call Text_Metr 
        call Pause05sek 

;-------------------------------------------------------------------------;
	 clrf Flag_F
;-------------------------------------------------------------------------;
_Restart
;  StBy  4.
	 incfsz StBy_L,f	
	goto $+6		
	 incf StBy_H,f	
	movlw    .3 	;   StBy.
      subwf    StBy_H,W 
 	btfsc STATUS,Z	
        call  PWR_OFF	; Power off.

;----------  LMETR----------------------------------------------
		btfsc		PORTA,3  
   	    goto $+2
           	goto LMETR 
;-------------------------------------------------------------------------;
;----------  F_metr----------------------------------------------
		btfsc		PORTA,Kn_Set  
   	    goto $+2
           	goto F_metr 
;-------------------------------------------------------------------------;
;---------- -------------------------------------------------;
		btfsc		PORTA,5  
   	    	goto Ser_m 
 		movlw .15
		movwf	Count1

	      call 	Pause03sek 
		btfsc	  PORTA,5 
   	    	goto Ser_m  
            decfsz  Count1, F
            goto    $-4

		bcf   PCLATH,3      ; 0
           call TEXT_Service
           call  MENU_Cx_1p
 		bsf   PCLATH,3      ; 1
Ser_m
;-------------------------------------------------------------------------;
;  . Lx.
	   movlw      0x2E
	call LO_EEPR
	   movwf  EE_Cx_p
;-------------------------------------------------------------------------;
;     LC .                                        
;    \A0\A1\A2\A3\ A0-A3=((F/10)*)(F/10/2))^2/10
       call LC_F
;-------------------------------------------------------------------------;
;****   5100  ********************************
	movf	 REGA3,f
	btfss STATUS,Z
       goto   A_C 
	movf	 REGA2,f
	btfss STATUS,Z
       goto   A_C 
	movlw    0x33	 ; 
        subwf    REGA1,0 ;
 	btfsc STATUS,C
       goto   A_C       ;

       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

        call  Line1	;   1- 	
	    call  Text_ERROR
            goto    _Restart
A_C
; . . Lx.
    	call  clrba
 		movlw 0x03
		movwf	 REGA1
		movlw 0x69
		movwf	 REGA0

		movf	 EE_Cx_p,W  ; . Lx.
		movwf	 REGB0
 	call  add               ; = 873 - 1127.
      call  CLR_REGB
		movf	 REGA1,W	
		movwf	 REGB1
		movf	 REGA0,W
		movwf	 REGB0

		movf	 A3,W	
		movwf	 REGA3
		movf	 A2,W
		movwf	 REGA2
		movf	 A1,W	
		movwf	 REGA1
		movf	 A0,W
		movwf	 REGA0
  	call  divide		;.
		movf	 REGA3,W	
		movwf	 REGB3
		movf	 REGA2,W
		movwf	 REGB2
		movf	 REGA1,W	
		movwf	 REGB1
		movf	 REGA0,W
		movwf	 REGB0
;REGB=F/. .Lx-------------

;************   C = 25330/L/F^2************************
;C=(25330/2)/(F/. .Lx) 
	movlw 0x4B	;   
	movwf REGA3	;

	movlw 0x7D	;  
	movwf REGA2	;

	movlw 0x41	;  
	movwf REGA1	;

	movlw 0xA0	;  
	movwf REGA0	;
  	call  divide		;.
;    .
;----------------------------------------------------------------------
	        btfsc  PORTA,Kn_Plus
	      goto   EN_CAL
	    call   Pause03sek
		btfsc  PORTA,Kn_Plus
	      goto   EN_CAL
       	    call  Line1
	    call   Text_Cal
       	    call  Line2
        call CLR_Line
;     EEPROM 2Ch.    
         movf  REGA1,0
            movwf   Temp 
 	 movlw      0x2C
	 call SAV_EEPR;     EEPROM W. TEMP. W

;     EEPROM 2Dh.     
         movf  REGA0,0
            movwf  Temp
 	 movlw      0x2D
	 call SAV_EEPR;     EEPROM W. TEMP. W
            call Pause05sek
	 call CLR_LCD ; 
EN_CAL
;---------------------------------------------------------------------------------------
    	      call  CLR_REGB
; ~ 650*10 Cx+C , 
; EEPROM     2Ch      REGB0.
	   movlw      0x2C
	call LO_EEPR
	   movwf      REGB1
;  EEPROM     45h      REGB0.
            movlw      0x2D           ;     EEPROM 2Dh
	call LO_EEPR
            movwf      REGB0          ;  45h   W   REGB0.

        call  subtract  	;. 
;******************   ******************************** 

;----------- ----------------------------------------------
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
            call  Line1 	;   1- 
 	     	movlw "C"
       	call  SendASCII 
       	movlw "x"
       	call  SendASCII 
       	movlw ">"
       	call  SendASCII 
;-----------------------------------------------------------------------
      call bin2dec     ;  REGA ---> DIGIT
;   
	btfss DSIGN,0
      goto   $+3
      	movlw "-"
      	call  SendASCII
;--------------------------------------------------------------------     
;  ------------------------------------------ 
	movlw    0x01	   ; 
        subwf    DIGIT8,0  ;
 	btfsc STATUS,C
        clrf  StBy_H           ;  StBy.


	movlw    0x01	   ; 
        subwf    DIGIT3,0  ;
 	btfsc STATUS,C
       goto  Cx_uF          ;   Lx- x.xx ukF

	movlw    0x01	   ; 
        subwf    DIGIT4,0  ;
 	btfsc STATUS,C
       goto  Cx_nF        ;   Lx- xx.xx nF

	movlw    0x01	   ; 
        subwf    DIGIT5,0  ;
 	btfsc STATUS,C
       goto   Cx_nF1       ;    Lx- x.xx nF

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   Cx_pF       ;   Lx- xxx.xx pF

	movlw    0x01	   ; 
        subwf    DIGIT7,0  ;
 	btfsc STATUS,C
       goto   Cx_pF1      ;   Lx- xx.xx pF 

       goto   Cx_pF2      ;   Lx- x.xx pF 
;-----------------------------------------------------------------------;
;           Cx- xxx.x pF                                ;
;-----------------------------------------------------------------------; 
Cx_pF1        movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
Cx_pF2       movf  DIGIT8,0
       addlw "0"
       call  SendASCII

      movf  DIGIT9,0
       addlw "0"
       call  SendASCII 

        movlw ","
       call  SendASCII 

      movf  DIGIT10,0
       addlw "0"
       call  SendASCII
   ;         call  Line2 	;   2- 
         movlw " "
       call  SendASCII 
       movlw "p"
       call  SendASCII
       movlw "F"
       call  SendASCII
	  
       goto    _Restart
;-----------------------------------------------------------------------;
;           Cx- xxxx pF                                ;
;-----------------------------------------------------------------------; 
Cx_pF
	movf  DIGIT6,0
       addlw "0"
       call  SendASCII   
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 
       movf  DIGIT8,0
       addlw "0"
       call  SendASCII

      movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
   ;         call  Line2 	;   2- 
         movlw " "
       call  SendASCII 
       movlw "p"
       call  SendASCII
       movlw "F"
       call  SendASCII
	  
       goto    _Restart

;-----------------------------------------------------------------------;
;             Cx-0.xxx uF                               ;
;-----------------------------------------------------------------------; 
Cx_nF1
Cx_nF  movf  DIGIT3,0
       addlw "0"
       call  SendASCII
       movlw "."
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII
;Cx_nF1
  movf  DIGIT5,0
       addlw "0"
       call  SendASCII
       movf  DIGIT6,0
       addlw "0"
       call  SendASCII
       movlw " "
       call  SendASCII
   ;         call  Line2 	;   2- 
       movlw 0x02  	; mu
       call  SendASCII
       movlw "F"
       call  SendASCII

        goto    _Restart
;----------------------------------------------------------------------;
;-----------------------------------------------------------------------;
;               Cx- x.xx ukF                               ;
;-----------------------------------------------------------------------; 
Cx_uF
       
       movf  DIGIT3,0
       addlw "0"
       call  SendASCII
        movlw ","
       call  SendASCII 
       movf  DIGIT4,0
       addlw "0"
       call  SendASCII 
        movf  DIGIT5,0
       addlw "0"
       call  SendASCII
          movlw " "
       call  SendASCII
   ;         call  Line2 	;   2- 
       movlw 0x02  	; mu
       call  SendASCII
        movlw "F"
       call  SendASCII	  
       goto    _Restart

;*******************************************************************
;********** ***************************************
;*******************************************************************
F_metr
                movlw   B'000000110'; 5-4 :    TMR1
       	    movwf   T1CON	      ;	 00=1:1   
	clrf	StBy_H
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.
;----------  F Metr-------------------------------------- 
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "F"
       call  SendASCII
	 call Text_Metr
       call Pause05sek 
 		btfss		PORTA,Kn_Set
	      goto $-1
;-------------------------------------------------------------------------;
            bsf    PORTC,3	;  ESR
            bcf    PORTC,2	;B  F
            bsf    PORTC,1	;  LC
;-------------------------------------------------------------------------;
F_start
;----------  pulse_count---------------------------------------;
		btfsc		PORTA,3  
   	    goto $+2
           	goto pulse_count
;-------------------------------------------------------------------------;
		call SW_F_metr
;  StBy  4.
	 incfsz StBy_L,f	
	goto $+2		
        call  PWR_OFF	; Power off.
        btfsc PORTA,Kn_Plus	; .+,  R.
	    goto $+3  
	clrf	StBy_H
	clrf	StBy_L
;----------------------------------------------------------------------------------
;   RC0  T=1sek-    \REGA0 \REGA1 \REGA02 \REGA3\ 
 
       call  Count_FHz ;  
;----------------------------------------------------------------------------------       
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
       call bin2dec     ;  REGA ---> DIGIT
 
;  ------------------------------------------------------------------ 

       call  Line1	;   1- 
;	 movlw " "
;       call  SendASCII
       movlw "F"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw ">"
       call  SendASCII
       call  FreqHz     ;  
       movlw "H"
       call  SendASCII
       movlw "z"
       call  SendASCII	
;----------------------------------------------------------------------------- 
 	 goto  F_start

pulse_count
	clrf	StBy_H
	clrf	StBy_L
          	bsf  PORTB,7		; Power on.
;----------  F Metr-------------------------------------- 
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

       call Line1
       movlw " "
       call  SendASCII
       movlw "P"
       call  SendASCII
       movlw "_"
       call  SendASCII
       movlw "C"
       call  SendASCII
	 call Text_Metr
      ; call Pause05sek 
;-------------------------------------------------------------------------;
            bsf    PORTC,3	;  ESR
            bcf    PORTC,2	;B  F
            bsf    PORTC,1	;  LC
;-------------------------------------------------------------------------;
    	 call  clrba
    	 clrf   A2
    	 clrf   A3
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1

pulse_count_1
            btfss      PIR1,0      ; TMR1   ?
            goto       $+5         ; ,   -->   .
       	bcf        PIR1,0	     ;     TMR1
            incf       A2,F        ; ,  -->    REGA2
            btfsc      STATUS,Z
            incf       A3,F
;---------------------
;  StBy  4.
	 incfsz StBy_L,f	;
	goto $+6
	 incf StBy_H,f	;
	movlw    0x04 	;   StBy.
      subwf    StBy_H,W ;
 	btfsc STATUS,Z
	call  PWR_OFF	; Power off.
;----------  F_metr---------------------------------------;
		btfss		PORTA,3  
   	    goto $+2
           	goto F_metr
;-----------------------------------------------------------------;
		call SW_F_metr
;-----------------------------------------------------------------;
    clrf   REGA1
    clrf   REGA0
            movlw       .84
            movwf       Temp4
            movlw       .5
            movwf       Temp

        btfsc PORTA,Kn_Plus	; .+,  R.
	    goto $+9  
	clrf	StBy_H
	clrf	StBy_L
        	call  clrba
    clrf   A2
    clrf   A3
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
	 goto $-9

       bsf     T1CON,0  ;0  TMR1  1=.
delC_P        movlw       .62
            movwf       Temp1
            movlw       .1
            movwf       Temp2
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
;===================================================================================;
;    TMR1   REGA2
;    REGA2   REGA3
;===================================================================================;
            btfss      PIR1,0      ; TMR1   ?
            goto       DoC_P         ; ,   -->     Do.
            incf       A2,F     ; ,  -->    REGA2
            btfsc      STATUS,Z
            incf       A3,F
            bcf        PIR1,0      ;    TMR1.
  
DoC_P        
            decfsz      Temp4,F 
            goto        delC_P
            decfsz      Temp,F               
            goto        delC_P


            btfss      PIR1,0      ; TMR1   ?
            goto       $+5         ; ,   -->   .
       	bcf        PIR1,0	     ;     TMR1
            incf       A2,F        ; ,  -->    REGA2
            btfsc      STATUS,Z
            incf       A3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 

		movf	 A2,W
		movwf	 REGA2
		movf	 A3,W
		movwf	 REGA3
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line
       call bin2dec     ;  REGA ---> DIGIT
       call  Line1	;   1- 
;	 movlw " "
;       call  SendASCII
       movlw "P"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw ">"
       call  SendASCII
       call  FreqHz     ;  

	goto  pulse_count_1

;*****************************************************************************
;****************** F Metr****************************************
SW_F_metr
;----------  ESR metr---------------------------------------
          btfsc	PORTA,Kn_Set  
  	    goto LF1
       call Line1    ; 
	 call CLR_Line
       call Line2 
	 call CLR_Line

         call Line1 
       movlw " "
       call  SendASCII
       movlw "E"
       call  SendASCII
       movlw "S"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw " "
       call  SendASCII
       movlw ">"
       call  SendASCII
;		call Text_Metr
       call Pause05sek 
            bsf    STATUS,RP0          ;  1
  		; 
		movlw	 b'10000100'	   ; , Vdd, Vss, AN0, AN1, AN3
		movwf	 ADCON1
            bcf    STATUS,RP0          ;  0
	        bcf   PCLATH,3
              goto START
LF1
		return
;-----------------------------------------------------------------------------;
;   RC0   Hz-    \REGA0\ REGA1\\REGA2\ REGA3\   ;
;  4433619 .
;-----------------------------------------------------------------------------;
Count_FHz 
            movlw       .84
            movwf       Temp4
            movlw       .5
            movwf       Temp
       	call  clrba
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
       bcf     PIR1,0	;     TMR1
       bsf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

;====    1======================================================

del         movlw       .71
            movwf       Temp1
            movlw       .2
            movwf       Temp2
wrF         decfsz      Temp1, F
            goto        wrF
            decfsz      Temp2, F
            goto        wrF
;===========================================================================================
;    TMR1   REGA2
;    REGA2   REGA3
;===========================================================================================
            btfss      PIR1,0      ; TMR1   ?
            goto       Do          ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F
  
            bcf        PIR1,0      ;    TMR1.
            nop 
            goto       CK          ;    CK.

Do          nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP. 8CIKL
            nop                    ;  NOP. 9CIKL
  
CK          decfsz      Temp4,F 
            goto        del
            decfsz      Temp,F               
            goto        del
;====     1 .=========================================
            movlw       .131
            movwf       Temp1
            decfsz      Temp1, F
	      goto   $-1
            nop
       ;     nop
       ;     nop ;!!!!!!!!!!!!
;====    1-================================================ 

       bcf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

            btfss      PIR1,0      ; TMR1   ?
            goto       $+4         ; ,   -->   .
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 

       return
;------------------------------------------------------------------------------------;
;     RC0 -    \REGA0\ REGA1\\REGA2\ REGA3\    ;
;------------------------------------------------------------------------------------;
;------------------------------------------------------------------------------------;
;      LCD 2*16                                                      ;
;------------------------------------------------------------------------------------;
FreqHz
;   ------------------------------------------ 
	movlw    0x01	   ; 
        subwf    DIGIT3,0  ;
 	btfsc STATUS,C
       goto  DIG8          ;   xx.xxx.xxx HZ

	movlw    0x01	   ; 
        subwf    DIGIT4,0  ;
 	btfsc STATUS,C
       goto  DIG7        ;   Lx-x.xxx.xxx HZ

	movlw    0x01	   ; 
        subwf    DIGIT5,0  ;
 	btfsc STATUS,C
       goto   DIG6       ;    Lx- xxx.xxx HZ

	movlw    0x01	   ; 
        subwf    DIGIT6,0  ;
 	btfsc STATUS,C
       goto   DIG5       ;   xx.xxx HZ
       goto   DIG4       ;   x.xxx HZ 


DIG8       movlw  0x082                 
       call   SendINS
	movf  DIGIT3,0
       addlw "0"
       call  SendASCII 
DIG7       movlw  0x083                 
       call   SendINS
	movf  DIGIT4,0
       addlw "0"
       call  SendASCII 
DIG6       movlw  0x084                 
       call   SendINS
       movlw " "
       call  SendASCII
	movf  DIGIT5,0
       addlw "0"
       call  SendASCII 

DIG5       movlw  0x086                
       call   SendINS
	movf  DIGIT6,0
       addlw "0"
       call  SendASCII 

DIG4         movlw  0x087                 
       call   SendINS
       movf  DIGIT7,0
       addlw "0"
       call  SendASCII 

   ;    call Line2 
       movlw " "
       call  SendASCII
       movf  DIGIT8,0
       addlw "0"
       call  SendASCII
       movf  DIGIT9,0
       addlw "0"
       call  SendASCII 
      movf  DIGIT10,0
       addlw "0"
       call  SendASCII 
       movlw " "
       call  SendASCII
  
      return  
  
;**********************************************************************************;
;****************** LC Metr********************************************;
;**********************************************************************************;
;----------------------------------------------------------------------------------;
;   RC0 F=F/20 Hz-    \REGA0\ REGA1\\REGA2\ REGA3\   ;
;  4433619 .
;----------------------------------------------------------------------------------;
Count_LC        movlw   B'000100110'; 5-4 :    TMR1
       	    movwf   T1CON	      ;	 10=1:4      
            movlw       .200
            movwf       Temp4
            movlw       .2
            movwf       Temp
        call  clrba
       clrf    TMR1H    ;TMR1H-  16-  1
       clrf    TMR1L	;TMR1L-  16-  1
       bcf     PIR1,0	;     TMR1
       bsf     T1CON,0  ;0  TMR1ON:  TMR1    1=.

;====    0.4============================================;

delC        movlw       .62
            movwf       Temp1
            movlw       .2
            movwf       Temp2
wrC         decfsz      Temp1, F
            goto        wrC
            decfsz      Temp2, F
            goto        wrC
;===================================================================================;
;    TMR1   REGA2
;    REGA2   REGA3
;===================================================================================;
            btfss      PIR1,0      ; TMR1   ?
            goto       DoC         ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F
  
            bcf        PIR1,0      ;    TMR1.
            goto       CKC         ;    CKC.

DoC         nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP.
            nop                    ;  NOP. 8CIKL
  
CKC         decfsz      Temp4,F 
            goto        delC
            decfsz      Temp,F               
            goto        delC
;  .......     0.4 ..............................
            movlw       .41
            movwf       Temp1
            decfsz      Temp1, F
	      goto   $-1
            nop
            nop
;====    0.4-========================================== 
            bcf     T1CON,0  	     ;0  TMR1ON:  TMR1    1=.
            btfss      PIR1,0      ; TMR1   ?
            goto       $+4         ; ,   -->     Do.
            incf       REGA2,F     ; ,  -->    REGA2
                                   ;       .
            btfsc      STATUS,Z
            incf       REGA3,F

       movf    TMR1H,0  ;TMR1H-  16-  1,0
       movwf   REGA1
       movf    TMR1L,0	;TMR1L-  16-  1,0
       movwf   REGA0	; c TMR1    REGA 

       return
;------------------------------------------------------------------------------------;
;   LC .                                          
;    \A0\A1\A2\A3\ A0-A3=((F/10)*)(F/10/2))^2/10
LC_F
           call  Count_LC    ;  LC 
		movf	 REGA2,W
		movwf	 A2
		movf	 REGA1,W
		movwf	 A1
		movf	 REGA0,W
		movwf	 A0

	movlw .2
	movwf REGB0
	call  divide	;.
           call  CLR_REGB
		movf	 A2,W
		movwf	 REGB2
		movf	 A1,W
		movwf	 REGB1
		movf	 A0,W
		movwf	 REGB0
	call multiply
	clrc
	rrf	REGA3,f
	rrf	REGA2,f	
	rrf	REGA1,f
	rrf	REGA0,f
      call  CLR_REGB
	movlw .5
	movwf REGB0
	call  divide	;.
		movf	 REGA3,W
		movwf	 A3
		movf	 REGA2,W
		movwf	 A2
		movf	 REGA1,W
		movwf	 A1
		movf	 REGA0,W
		movwf	 A0
       return
;---------------------------------------------------------------------------------- 
;***************   Lx ************************************************
Cal_L
	 call Line1 
	call Text_Cal
; . . Lx.
    	call  clrba
		movlw .15
		movwf	 REGA0
		movf	 EE_Lx_p,W  ; . Lx.
		movwf	 REGB0
  	call  multiply	
		movf	 REGA1,W	
		movwf	 REGB1
		movf	 REGA0,W
		movwf	 REGB0

      	movlw 0x1F
		movwf	 REGA1
		movlw 0x9F
		movwf	 REGA0

 	call  add               ; = 8095 - 11905.
      call  CLR_REGB
		movf	 REGA1,W	
		movwf	 REGB1
		movf	 REGA0,W
		movwf	 REGB0

		movf	 A3,W	
		movwf	 REGA3
		movf	 A2,W
		movwf	 REGA2
		movf	 A1,W	
		movwf	 REGA1
		movf	 A0,W
		movwf	 REGA0
  	call  divide		;.
		movf	 REGA3,W	
		movwf	 REGB3
		movf	 REGA2,W
		movwf	 REGB2
		movf	 REGA1,W	
		movwf	 REGB1
		movf	 REGA0,W
		movwf	 REGB0
;REGB=F/. .Lx-------------
;************   C = 25330/L/F^2************************
;C=(25330/2)/(F/. .Lx) 
	movlw 0x4B	;   
	movwf REGA3	;

	movlw 0x7D	;  
	movwf REGA2	;

	movlw 0x41	;  
	movwf REGA1	;

	movlw 0xA0	;  
	movwf REGA0	;
  	call  divide		;.
      call  CLR_REGB
	movlw .10
	movwf REGB0	;
  	call  divide		;.
;  .

;-------------------   EEPROM --------------------------------------------------
;     EEPROM 24h.    
        movf  REGA1,0
            movwf   Temp 
 	 movlw      0x24
	call SAV_EEPR
;     EEPROM 25h.     
         movf  REGA0,0
            movwf  Temp
 	 movlw      0x25
	call SAV_EEPR

       call bin2dec     ;  REGA ---> DIGIT

        call Line2 
        movlw "C"
        call  SendASCII
        movlw "x"
        call  SendASCII
        movlw " "
        call  SendASCII
        movf  DIGIT7,0
        addlw "0"
        call  SendASCII
        movf  DIGIT8,0
        addlw "0"
        call  SendASCII
        movf  DIGIT9,0
        addlw "0"
        call  SendASCII 
        movf  DIGIT10,0
        addlw "0"
        call  SendASCII 

        movlw "p"
        call  SendASCII
        movlw "F"
        call  SendASCII
; 10000  +, 0
;  EEPROM  2-  
;     EEPROM 29h. 
        movf  T2,0
            movwf   Temp 
 	 movlw      0x29
	call SAV_EEPR
;     EEPROM 28h. 
         movf  T3,0
            movwf  Temp
 	 movlw      0x28
	call SAV_EEPR

            call Pause05sek 
       call CLR_LCD    ; 
          return
;***************  ***************************
;===============================================================================================
;      movlw 0x--h      W.  pF
;-----------------------------------------------------------------------------------------------
;      XXh      W.

LO_EEPR
            bsf        STATUS,RP1
            bcf        STATUS,RP0     ;    2.
            movwf      EEADR          ;  24h   W   EEAdr.
            bsf        STATUS,RP0       ;    3.
            bcf        EECON1,EEPGD     ; EEPROM .
	      bsf	     EECON1,RD        ; 
            bcf        STATUS,RP0       ;     2.
            movf       EEDATA,W    ;     EEPROM   25h   W.
	    bcf    STATUS,RP1
 	    bcf    STATUS,RP0	   ;   0
 		return
;-------------------   EEPROM --------------------------------------------------
;     EEPROM W. TEMP.
SAV_EEPR	    bsf        STATUS,RP1
            bsf        STATUS,RP0      ;    3.
	    btfsc        EECON1,WR
	    goto   $-1
	    bcf        STATUS,RP0      ;     2.
          movwf      EEADR           ;  00h   W   EEAdr.
	bcf    STATUS,RP1
 	bcf    STATUS,RP0	   ;   0
            movf       Temp,W 
	      bsf        STATUS,RP1      ;     2.
            movwf      EEDATA          ;     W   EEDATA
            bsf        STATUS,RP0      ;    3.
            bcf        EECON1,EEPGD    ;  EEPROM .
	      bsf        EECON1,WREN     ;  
            bcf        INTCON,GIE      ;   .            
            movlw      055h            ; 
            movwf      EECON2          ; 
            movlw      0AAh            ;  .
            movwf      EECON2          ; ----"----
            bsf        EECON1,WR       ;  
           ;bcf        INTCON,GIE      ;  . 
            bcf        EECON1,WREN     ;  
	bcf    STATUS,RP1
 	bcf    STATUS,RP0	   ;   0
 		return

;*************************************************************************
Text_Metr
       movlw " "
       call  SendASCII
       movlw "M"
       call  SendASCII
       movlw "e"
       call  SendASCII
       movlw "t"
       call  SendASCII
       movlw "r"
       call  SendASCII
       return 
Text_Lx
       movlw " "
       call  SendASCII
       movlw "L"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw "-"
       call  SendASCII
       movlw "-"
       call  SendASCII
       movlw "-"
       call  SendASCII
       return 
Text_ERROR
       movlw " "
       call  SendASCII
       movlw "C"
       call  SendASCII
       movlw "x"
       call  SendASCII
       movlw " "
       call  SendASCII
       movlw "E"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw "R"
       call  SendASCII
       movlw "O"
       call  SendASCII
       movlw "R"
       call  SendASCII

       return 
Text_Cal
        movlw " "
       call  SendASCII      
        movlw "C"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "l"
        call  SendASCII
        movlw "i"
       call  SendASCII
        movlw "b"
        call  SendASCII
        movlw "r"
        call  SendASCII
        movlw "a"
       call  SendASCII
        movlw "t"
        call  SendASCII
        movlw "i"
        call  SendASCII
        movlw "o"
       call  SendASCII
        movlw "n"
       call  SendASCII
	return
Text_save
        movlw " "
        call  SendASCII
        movlw "S"
        call  SendASCII
        movlw "a"
        call  SendASCII
        movlw "v"
        call  SendASCII
        movlw "e"
        call  SendASCII
        movlw " "
        call  SendASCII
        movlw "E"
        call  SendASCII
        movlw "E"
        call  SendASCII
        movlw "P"
        call  SendASCII
        movlw "R"
        call  SendASCII
        movlw "O"
        call  SendASCII
        movlw "M"
        call  SendASCII
	return
;----------------------------------------------------------------------;
; ( t=  4).                           ;
;----------------------------------------------------------------------;
Pause05sek 
;delay = 499'996 machine cycles
            movlw       .84
            movwf       Temp1
            movlw       .138
            movwf       Temp2
            movlw       .3
            movwf       Temp3
L3          decfsz      Temp1, F
            goto        L3
            decfsz      Temp2, F
            goto        L3
            decfsz      Temp3, F
            goto        L3
            nop
          	return
Pause03sek 
;delay = 299'996 machine cycles
            movlw       .151
            movwf       Temp1
            movlw       .134
            movwf       Temp2
            movlw       .2
            movwf       Temp3
            decfsz      Temp1, F
            goto        $-1
            decfsz      Temp2, F
            goto        $-3
            decfsz      Temp3, F
            goto        $-5
            nop
            nop
          	return
CLR_REGB	;  REGB
	clrf	REGB0	
	clrf	REGB1
	clrf	REGB2
	clrf	REGB3
          	return
;********************************************************************************
;**************   ***************************************
;*** 32 BIT SIGNED SUTRACT ***
;REGA - REGB -> REGA
;Return carry set if overflow

subtract
	call	negateb		;Negate REGB
	skpnc
	return			;Overflow

;*** 32 BIT SIGNED ADD ***
;REGA + REGB -> REGA
;Return carry set if overflow

add	movf	REGA3,w		;Compare signs
	xorwf	REGB3,w
	movwf	MTEMP

	call	addba		;Add REGB to REGA

	clrc			;Check signs
	movf	REGB3,w		;If signs are same
	xorwf	REGA3,w		;so must result sign
	btfss	MTEMP,7		;else overflow
	addlw	0x80
	return

;*** 32 BIT SIGNED MULTIPLY ***
;REGA * REGB -> REGA
;Return carry set if overflow

multiply
	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpc
	call	absb		;Make REGB positive
	skpnc
	return			;Overflow

	call	movac		;Move REGA to REGC
	call	clra		;Clear product

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

muloop	call	slac		;Shift left product and multiplicand
	
	rlf	REGC3,w		;Test MSB of multiplicand
	skpnc			;If multiplicand bit is a 1 then
	call	addba		;add multiplier to product

	skpc			;Check for overflow
	rlf	REGA3,w
	skpnc
	return

	decfsz	MCOUNT,f	;Next
	goto	muloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

;*** 32 BIT SIGNED DIVIDE ***
;REGA / REGB -> REGA
;Remainder in REGC
;Return carry set if overflow or division by zero

divide	clrf	MTEMP		;Reset sign flag
	movf	REGB0,w		;Trap division by zero
	iorwf	REGB1,w
	iorwf	REGB2,w
	iorwf	REGB3,w
	sublw	0
	skpc
	call	absa		;Make dividend (REGA) positive
	skpc
	call	absb		;Make divisor (REGB) positive
	skpnc
	return			;Overflow

	clrf	REGC0		;Clear remainder
	clrf	REGC1
	clrf	REGC2
	clrf	REGC3
	call	slac		;Purge sign bit

	movlw	D'31'		;Loop counter
	movwf	MCOUNT

dvloop	call	slac		;Shift dividend (REGA) msb into remainder (REGC)

	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	dtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	dtstgt
	movf	REGB0,w
	subwf	REGC0,w
dtstgt	skpc			;Carry set if remainder >= divisor
	goto	dremlt

	movf	REGB0,w		;Subtract divisor (REGB) from remainder (REGC)
	subwf	REGC0,f
	movf	REGB1,w
	skpc
	incfsz	REGB1,w
	subwf	REGC1,f
	movf	REGB2,w
	skpc
	incfsz	REGB2,w
	subwf	REGC2,f
	movf	REGB3,w
	skpc
	incfsz	REGB3,w
	subwf	REGC3,f
	clrc
	bsf	REGA0,0		;Set quotient bit

dremlt	decfsz	MCOUNT,f	;Next
	goto	dvloop

	btfsc	MTEMP,0		;Check result sign
	call	negatea		;Negative
	return

;*** ROUND RESULT OF DIVISION TO NEAREST INTEGER ***
round	clrf	MTEMP		;Reset sign flag
	call	absa		;Make positive
	clrc
	call	slc		;Multiply remainder by 2
	movf	REGB3,w		;Test if remainder (REGC) >= divisor (REGB)
	subwf	REGC3,w
	skpz
	goto	rtstgt
	movf	REGB2,w
	subwf	REGC2,w
	skpz
	goto	dtstgt
	movf	REGB1,w
	subwf	REGC1,w
	skpz
	goto	rtstgt
	movf	REGB0,w
	subwf	REGC0,w
rtstgt	skpc			;Carry set if remainder >= divisor
	goto	rremlt
	incfsz	REGA0,f		;Add 1 to quotient
	goto	rremlt
	incfsz	REGA1,f
	goto	rremlt
	incfsz	REGA2,f
	goto	rremlt
	incf	REGA3,f
	skpnz
	return			;Overflow,return carry set
rremlt	btfsc	MTEMP,0		;Restore sign
	call	negatea
	return


;*** 32 BIT SQUARE ROOT ***
;sqrt(REGA) -> REGA
;Return carry set if negative

sqrt	rlf	REGA3,w		;Trap negative values
	skpnc
	return

	call	movac		;Move REGA to REGC
	call	clrba		;Clear remainder (REGB) and root (REGA)

	movlw	D'16'		;Loop counter
	movwf	MCOUNT

sqloop	rlf	REGC0,f		;Shift two msb's
	rlf	REGC1,f		;into remainder
	rlf	REGC2,f
	rlf	REGC3,f
	rlf	REGB0,f
	rlf	REGB1,f
	rlf	REGB2,f
	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	rlf	REGB0,f
	rlf	REGB1,f
	rlf	REGB2,f

	setc			;Add 1 to root
	rlf	REGA0,f		;Align root
	rlf	REGA1,f
	rlf	REGA2,f

	movf	REGA2,w		;Test if remdr (REGB) >= root (REGA)
	subwf	REGB2,w
	skpz
	goto	ststgt
	movf	REGA1,w
	subwf	REGB1,w
	skpz
	goto	ststgt
	movf	REGA0,w
	subwf	REGB0,w
ststgt	skpc			;Carry set if remdr >= root
	goto	sremlt

	movf	REGA0,w		;Subtract root (REGA) from remdr (REGB)
	subwf	REGB0,f
	movf	REGA1,w
	skpc
	incfsz	REGA1,w
	subwf	REGB1,f
	movf	REGA2,w
	skpc
	incfsz	REGA2,w
	subwf	REGB2,f
	bsf	REGA0,1		;Set current root bit

sremlt	bcf	REGA0,0		;Clear test bit
	decfsz	MCOUNT,f	;Next
	goto	sqloop

	clrc
	rrf	REGA2,f		;Adjust root alignment
	rrf	REGA1,f
	rrf	REGA0,f
	return


;*** 32 BIT SIGNED BINARY TO DECIMAL ***
;REGA -> DIGITS 1 (MSD) TO 10 (LSD) & DSIGN
;DSIGN = 0 if REGA is positive, 1 if negative
;Return carry set if overflow
;Uses FSR register

bin2dec	clrf	MTEMP		;Reset sign flag
	call	absa		;Make REGA positive
	skpnc
	return			;Overflow

	call	clrdig		;Clear all digits

	movlw	D'32'		;Loop counter
	movwf	MCOUNT

b2dloop	rlf	REGA0,f		;Shift msb into carry
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f

	movlw	DIGIT10
	movwf	FSR		;Pointer to digits
	movlw	D'10'		;10 digits to do
	movwf	DCOUNT

adjlp	rlf	INDF,f		;Shift digit and carry 1 bit left
	movlw	D'10'
	subwf	INDF,w		;Check and adjust for decimal overflow
	skpnc
	movwf	INDF

	decf	FSR,f		;Next digit
	decfsz	DCOUNT,f
	goto	adjlp

	decfsz	MCOUNT,f	;Next bit
	goto	b2dloop

	btfsc	MTEMP,0		;Check sign
	bsf	DSIGN,0		;Negative
	clrc
	return


;*** 32 BIT SIGNED DECIMAL TO BINARY ***
; *** 32     () ***
;Decimal DIGIT1 thro DIGIT(X) & DSIGN -> REGA
;Set DSIGN = 0 for positive, DSIGN = 1 for negative values
;Most significant digit in DIGIT1
;Enter this routine with digit count in w register
;Return carry set if overflow
;Uses FSR register

dec2bin	movwf	MTEMP		;Save digit count

	movlw	D'32'		;Outer bit loop counter
	movwf	MCOUNT

d2blp1	movlw	DIGIT1-1	;Set up pointer to MSD
	movwf	FSR
	movf	MTEMP,w		;Inner digit loop counter
	movwf	DCOUNT

	movlw	D'10'
	clrc			;Bring in '0' bit into MSD

d2blp2	incf	FSR,f
	skpnc
	addwf	INDF,f		;Add 10 if '1' bit from prev digit
	rrf	INDF,f		;Shift out LSB of digit

	decfsz	DCOUNT,f	;Next L.S. Digit
	goto	d2blp2

	rrf	REGA3,f		;Shift in carry from digits
	rrf	REGA2,f
	rrf	REGA1,f
	rrf	REGA0,f

	decfsz	MCOUNT,f	;Next bit
	goto	d2blp1

	movf	INDF,w		;Check for overflow
	addlw	0xFF
	skpc
	rlf	REGA3,w
	skpnc
	return

	btfsc	DSIGN,0		;Check result sign
	call	negatea		;Negative
	return


;UTILITY ROUTINES


;Add REGB to REGA (Unsigned)
;Used by add, multiply,

addba	movf	REGB0,w		;Add lo byte
	addwf	REGA0,f

	movf	REGB1,w		;Add mid-lo byte
	skpnc			;No carry_in, so just add
	incfsz	REGB1,w		;Add carry_in to REGB
	addwf	REGA1,f		;Add and propagate carry_out

	movf	REGB2,w		;Add mid-hi byte
	skpnc
	incfsz	REGB2,w
	addwf	REGA2,f

	movf	REGB3,w		;Add hi byte
	skpnc
	incfsz	REGB3,w
	addwf	REGA3,f
	return


;Move REGA to REGC
;Used by multiply, sqrt

movac	movf	REGA0,w
	movwf	REGC0
	movf	REGA1,w
	movwf	REGC1
	movf	REGA2,w
	movwf	REGC2
	movf	REGA3,w
	movwf	REGC3
	return


;Clear REGB and REGA
;Used by sqrt

clrba	clrf	REGB0
	clrf	REGB1
	clrf	REGB2
	clrf	REGB3

;Clear REGA
;Used by multiply, sqrt

clra	clrf	REGA0
	clrf	REGA1
	clrf	REGA2
	clrf	REGA3
	return


;Check sign of REGA and convert negative to positive
;Used by multiply, divide, bin2dec, round

absa	rlf	REGA3,w
	skpc
	return			;Positive

;Negate REGA
;Used by absa, multiply, divide, bin2dec, dec2bin, round

negatea	movf	REGA3,w		;Save sign in w
	andlw	0x80

	comf	REGA0,f		;2's complement
	comf	REGA1,f
	comf	REGA2,f
	comf	REGA3,f
	incfsz	REGA0,f
	goto	nega1
	incfsz	REGA1,f
	goto	nega1
	incfsz	REGA2,f
	goto	nega1
	incf	REGA3,f
nega1
	incf	MTEMP,f		;flip sign flag
	addwf	REGA3,w		;Return carry set if -2147483648
	return


;Check sign of REGB and convert negative to positive
;Used by multiply, divide

absb	rlf	REGB3,w
	skpc
	return			;Positive

;Negate REGB
;Used by absb, subtract, multiply, divide

negateb	movf	REGB3,w		;Save sign in w
	andlw	0x80

	comf	REGB0,f		;2's complement
	comf	REGB1,f
	comf	REGB2,f
	comf	REGB3,f
	incfsz	REGB0,f
	goto	negb1
	incfsz	REGB1,f
	goto	negb1
	incfsz	REGB2,f
	goto	negb1
	incf	REGB3,f
negb1
	incf	MTEMP,f		;flip sign flag
	addwf	REGB3,w		;Return carry set if -2147483648
	return


;Shift left REGA and REGC
;Used by multiply, divide, round

slac	rlf	REGA0,f
	rlf	REGA1,f
	rlf	REGA2,f
	rlf	REGA3,f
slc	rlf	REGC0,f
	rlf	REGC1,f
	rlf	REGC2,f
	rlf	REGC3,f
	return

;Set all digits to 0
;Used by bin2dec

clrdig	clrf	DSIGN
	clrf	DIGIT1
	clrf	DIGIT2
	clrf	DIGIT3
	clrf	DIGIT4
	clrf	DIGIT5
	clrf	DIGIT6
	clrf	DIGIT7
	clrf	DIGIT8
	clrf	DIGIT9
	clrf	DIGIT10
	return

;===================================================
PWR_OFF
;   LCD
       call  Line1	            ;   1- 
       call  CLR_Line
       call  Line2	            ;   2- 
       call  CLR_Line
       call  Line1	            ;   1- 
       movlw  " "		
       call  SendASCII
       movlw  "P"		
       call  SendASCII
       movlw  "W"		
       call  SendASCII
       movlw  "R"		
       call  SendASCII
       movlw  "_"	
       call  SendASCII

	 movlw  "o"		
       call  SendASCII
       movlw  "f"		
       call  SendASCII
       movlw  "f"		
       call  SendASCII
;delay = 10'000'000 machine cycles
      	movlw       .223
            movwf       Temp1
            movlw       .187
            movwf       Temp2
            movlw       .51
            movwf       Temp3
wr_stby     decfsz      Temp1, F
            goto        wr_stby 
          btfss PORTA,Kn_Plus	; .+,  R.
	    return
            decfsz      Temp2, F
            goto        wr_stby 
            decfsz      Temp3, F
            goto        wr_stby 
       bcf  PORTB,7		; Power off.
	 call Pause05sek 
	 call Pause05sek 
	clrf	StBy_H
	clrf	StBy_L
       bsf  PORTB,7		; Power on.
         return

;----------------------------------------------------------------------;
;  Ubat.
Ubat
	   	call  clrba
		movlw		b'10001001'   ;Fosc/32,  1,   .
		movwf		ADCON0
            movlw       .5
        	movwf       Temp1
            decfsz      Temp1, F
            goto        $-1
		bsf		ADCON0,2	  ; - 
		btfsc		ADCON0,2
		goto		$-1		  ;   
		movf	 ADRESH,W
		movwf	 BCD1
            bsf    STATUS,RP0          ;  1
		movf	 ADRESL,W
            bcf    STATUS,RP0          ;  0
		movwf	 BCD0

		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
       movlw  0x0CE                 
       call   SendINS
;    512(200), Bat max.
	movlw    0x02 
      subwf    REGA1,W ;
 	btfss STATUS,Z
	 goto   $+4
       movlw .3 		; Bat max
       call  SendASCII
	 goto   Ubat_end

        call  clrba
		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
	movlw 0x01	;483  
      movwf REGB1	;
	movlw 0xE3	;
      movwf REGB0	;
   call  subtract	;.    REGA = 0
	movf   REGA3,f   	;  ,  Bat max-1.
      btfss   STATUS,Z  
   	 goto   $+4
       movlw .4 		; Bat max-1
       call  SendASCII
	 goto   Ubat_end

        call  clrba
		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
	movlw 0x01	;455  
      movwf REGB1	;
	movlw 0xC7	;
      movwf REGB0	;
   call  subtract	;.    REGA = 0
	movf   REGA3,f   	;  ,  Bat max-2.
      btfss   STATUS,Z 
   	 goto   $+4
       movlw .5 		; Bat max-2
       call  SendASCII
	 goto   Ubat_end

        call  clrba
		movf	 BCD1,W
		movwf	 REGA1
		movf	 BCD0,W
		movwf	 REGA0
	movlw 0x01	;427  
      movwf REGB1	;
	movlw 0xAB	;
      movwf REGB0	;
   call  subtract 	;.    REGA = 0
	movf   REGA3,f   	;  ,  REG_MAT
      btfss   STATUS,Z 
   	 goto   $+4
       movlw .6 		; Bat max-3
       call  SendASCII
	 goto   Ubat_end

        movlw .7		; Bat max-4
       call  SendASCII
Ubat_end
		return
;-------------------------------------------------------------------------;
;  
	INCLUDE "LCD.inc"
	NOP
       END
